Index: trunk/Poubelle/archTOI.old/toiiter.h
===================================================================
--- trunk/Poubelle/archTOI.old/toiiter.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/toiiter.h	(revision 534)
@@ -1,197 +1,93 @@
 // toiiter.h
-// Eric Aubourg         CEA/DAPNIA/SPP   juillet 1999
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
 
 #ifndef TOIITER_H
 #define TOIITER_H
 
-
 #include <vector>
+#include <list>
 #include <set>
 #include <map>
 #include <string>
-#include "archeopsfile.h"
-#include "auxgps.h"
-#include "tsid.h"
 
-enum TOIKind {
-  sampleNum,     // Numero d''echantillon (timer interne transputer)
-  internalTime,  // temps transputer depuis debut manip, en secondes.
-  mjd,           // UTC (en jours, MJD = JD - 2450000).
-  mutc,          // UTC en heure, avec soustraction d'origine
-  boloMuV,       // tension en microVolts, filtree avec filtre carre indexe par bolometre
-  boloMuV2,      // tension en microVolts, avec soustraction offset filtre
-  boloRawMuV,    // tension brute en microVolts, non filtree indexe par bolometre, sans chgt signe
-  boloTemp,      // Kelvins, need R(T) -> N/A
-  boloDACV,      // tension de reference du DAC (microVolts)
-  boloDACI,      // courant (microAmps)
-  boloRawMuVCN,  // compression noise on bolo (microVolts), no filter
-  boloMuV2T,     // total, microVolts, avec consigne DAC
-  boloRes,       // Resistance, ohms
-  boloGainAmpli, //
-  dilDAC,        // dilution DAC, index = 0-47
-  dilSwitch,     // dilution, mot de 32 bits
-  serviceTemp,   // service temperature, K
-  sstDiode,      // signal brut SST, indice = diode, 0-45
-  sstChannel,    // signal brut SST, indice = canal, 0-47
-  sstDiodeCN,    // compression noise
-  sstChannelCN,  // compression noise
-  sstStarCnt,    // nombre d''etoiles detectees durant ce sample
-  sstStarZ,      // numero de diode d''une eventuelle etoile,   i=etoile 0..n
-  sstStarF,      // flux d''une eventuelle etoile,             <0 si moins de i+1 etoiles
-  sstStarT,      // temps d''une eventuelle etoile,            <0 si moins de i+1 etoiles
-  gyroRaw,       // valeur brute du gyro, index = 0,1,2
-  gyroV,         // tension gyro, V, index = 0,1,2
-  gyroSpeed,     // vitesse gyro, deg/s, index = 0,1,2, calibree...
-  gpsTime,       // temps fourni par GPS
-  longitude,     // position ballon, degrees  +=EST
-  latitude,      // position ballon, degrees  +=NORD
-  altitude,      // position ballon, m
-  tsid,          // temps sideral en secondes
-  azimuthBolo,   // azimut 
-  alphaRotAxis,  // 
-  deltaRotAxis,  //
-  alphaZenith,   // 
-  deltaZenith,   //
-  alphaSst,      // 
-  deltaSst,      //
-  alphaFPAxis,   //
-  deltaFPAxis,   //
-  alphaBolo,     // sur le ciel, indexe par bolometre
-  deltaBolo,     // sur le ciel, indexe par bolometre
-  voyantEVO,
-  voyantEVF,
-  commandeEV0,
-  commandeEVF,
-  commandeEVB,
-  commandeEVV,
-  pressEnt3He,
-  debit3He,
-  pressSor3He,
-  pressEnt4He,
-  debit4He,
-  pressSor4He,
-  pressAirVanne,
-  pressPompChar,
-  pressMembrane,
-  pressExterne,
-  tensPile10T,
-  tensPileP18D,
-  tensPileM18D,
-  tensPile10B,
-  tensPileP18B,
-  tensPileM18B,
-  tensPileCh,
-  swPile5,
-  swPile15,
-  tempCaissH1,
-  tempCaissH2,
-  tempCaissB1,
-  tempCaissB2,
-  tempCaissTHe,
-  tempCaissPiles,
-  tempCaissDrv,
-  pressHeBain,
-  pressPirani
-}; 
+#include "toiabsorber.h"
+#include "requesthandler.h"
+#include "archfileset.h"
 
-class TOIInterpolator;
+class AuxGPS;
 
-class TOIIter {
+template <class T1, class T2, class T3>
+struct triple {
+    T1 first;
+    T2 second;
+    T3 third;
+	triple() : first(T1()), second(T2()), third(T3()) {}
+    triple (const T1& a, const T2& b, const T3& c) :
+           first (a), second (b), third (c) {}
+};
+
+class TOIIter : public TOIAbsorber /*, public RequestHandler*/ {
 public:
-   TOIIter(TOIIter const&);   // $CHECK$ prevoir operator = ?
-   ~TOIIter();
-   bool Next();
+  TOIIter();
+  // ~TOIIter();
+  
+  void readReq(istream& s);
+  void defaultInclude();
+
+  bool processRequest(string line);
+  void registerReqHandler(RequestHandler*);
+
+  virtual bool processTOIReq(TOI& toi, string);
+  virtual bool processOption(string keyw, string args);
+
+  void addDirectory(string);
+  void addFile(string);
+  //void useAuxGPS(AuxGPS* gps);
    
-   bool    canGetValue(int column);  // data is available for that...
-   double  getValue(int column);
-   bool    newValue(int column);     // a juste change ?
-   bool    extendValue(int column);  // une valeur plus ancienne, etendue ?
-   bool    interpValue(int column);  // une valeur interpolee avec valeur future ?
-   bool    isTrig(int column);  
-   TOIKind getKind(int column);
-   int     getIndex(int column);     // si plusieurs, exemple, tension bolo 2
+  void setMJDInterval(double tStart, double tEnd);
+  void setUTCInterval(double tStart, double tEnd);
+  void setSNInterval(long sStart, long sEnd);
+  void setUnderSample(int n);
+  int  getUnderSample();
+
+  void addTOI(TOI& toi, bool triggering=true);
+
+  void init();
+  
+  bool next();
    
-   bool    canGetTOI(TOIKind kind, int index=0);
-   double  getTOI(TOIKind kind, int index=0);
+  long    getSampleNum();
+  bool    canGetValue(int column);  // data is available for that...
+  double  getValue(int column);
+  bool    canGetValue(TOI const& toi);  // data is available for that...
+  double  getValue(TOI const& toi);
+  bool    newValue(int column);     // a juste change ?
+  bool    extendValue(int column);  // une valeur plus ancienne, etendue ?
+  bool    interpValue(int column);  // une valeur interpolee avec valeur future ?
+  bool    isTrig(int column);  
+  TOI     getKind(int column);
+  
+  ArchFileSet& getFSet() {return fset;}
+      
+protected:   
+  ArchFileSet fset;
+  list<RequestHandler*> handlers;
+  enum {triggering = 1};
+  typedef ::triple<TOI,TOIProducer*,long> TOIInfo;
+  vector<TOIInfo> request; 
    
+  double mjdStart, mjdEnd;  // MJD
+  double utcStart, utcEnd;  // UTC, will be converted towards tStart tEnd at init
+  long   sStart, sEnd;      // samplenum
+        
+  int underSample;
+  long curSample;
    
-   int    getBlockSampleIndex();        // numero d''echantillon dans dernier bloc bolo
-   int    getSampleIndex();             // numero d''echantillon 
-   int    getUnderSampling();           
-   double getMJD();            
+  int getColTOI(TOI const& toi);
+  bool next1();
 
-   block_type_param*         lastParam();  
-   block_type_journal*       lastJournal();
-   block_type_reglage*       lastReglage();
-   block_type_dilution*      lastDilution();
-   block_type_gps*           lastGPS();
-   block_type_une_periode*   lastUnePeriode();
-   block_type_synchro_sol*   lastSynchroSol();
-   block_type_pointage_sol*  lastPointageSol();
-   block_type_bolo*          lastBolo();   
-   block_type_gyro*          lastGyro();
-   block_type_sst*           lastSST();
-   block_type_bolo_comprime* lastBoloComp();   
-   block_type_gyro_comprime* lastGyroComp();
-   block_type_sst_comprime*  lastSSTComp();
-   
-   ArcheopsFile* currentFile() {if (!initDone) Init(); return file;}
-
-protected:
-   TOIIter();
-   void Init(); // After setting the options, opens the first file.
-   void ScanFiles(); // Parcourt tous les fichiers, cherche le premier echantillon...
-   
-   bool Next1();
-   bool NextSample(); // no test of trange
-   bool NextFile();
-   
-   ArcheopsFile* file;
-   string directory;   // If directory scanning
-   set<string> files;  // list of files to be read...
-   map<string, long> file1stSamp; // premier echantillon de chaque fichier
-   set<string>::iterator curFile;
-   bool  isOnBoardRecorder;
-   
-   int imes;
-   
-   double tStart, tEnd;      // MJD
-   double utcStart, utcEnd;  // UTC, will be converted towards tStart tEnd at init
-   long   sStart, sEnd;      // samplenum
-   
-   //double tBlock0;  // MJD du bloc numero zero...
-   //double perEch;   // periode d''echantillonage en secondes
-   
-   struct info {
-     TOIKind kind;
-     int index;
-     bool triggering;
-     bool interpolated;
-   };
-   
-   int getColTOI(TOIKind kind, int index=0);
-   
-   long trigMask;
-   
-   vector<info>   infos;
-   
-   friend class TOISvr;
-   
-   // Gestion de l''interpolation, par delegation a un autre iterateur
-   TOIIter* rawIter; // iterateur sans interpolation, qui avance avec retard
-                     // en bufferisant les valeurs. S''il existe, on lui delegue
-                     // toutes les operations agissant sur le fichier.
-   TOIInterpolator* interp; // interpolateurs pour stocker les valeurs
-   long lastSample;  // last interpolated sample
-   long maxLookAhead;
-   bool fetchAhead(); // avance d''une TOI en nourrissant les interpolateurs
-   
-   AuxGPS* auxGPS;
-   TSid tSid;
-   
-   int underSample;
-   
-   private:
-   bool initDone;
+private:
+  bool initDone;
+  bool incDone;
 };
 
Index: trunk/Poubelle/archTOI.old/toillboloproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toillboloproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillboloproducer.cc	(revision 534)
@@ -0,0 +1,70 @@
+// toillboloproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#include "toillboloproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+#define raw "rawBoloData"
+#define muv "boloRawMuV"
+#define muvCN "boloRawMuVCN"
+
+#define  val_DS(j,i)  (blk->data_bolo[j][i]&0x1fffff)
+
+TOILLBoloProducer::TOILLBoloProducer()
+{
+  possibleTOIs.insert(TOI(raw, TOI::all, "", "ADU"));  
+  possibleTOIs.insert(TOI(muv, TOI::all, "", "microVolts"));
+  possibleTOIs.insert(TOI(muvCN, TOI::all, "", "microVolts"));
+}
+
+string TOILLBoloProducer::getName() {
+  return("TOILLBoloProducer 1.0");
+}
+
+
+void TOILLBoloProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_bolo* blk = fs->lastBolo();
+  long sample0 = numero_block(blk)*72;
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    int ibolo = (*i).index;
+    if ((*i).name == raw) {
+      for (int j=0; j<nb_per_block*2; j++) {
+        computedValue((*i),sample0+j, val_DS(ibolo,j));
+      }
+    } else if ((*i).name == muv) {
+      block_type_reglage* reglage = fs->lastReglage();
+      block_type_param*   param   = fs->lastParam();
+      for (int j=0; j<nb_per_block*2; j++) {
+        int s = j % 2 ? 1 : -1;
+        computedValue((*i),sample0+j, 
+          s*bolo_muV(&param->param, &reglage->reglage, val_DS(ibolo,j), ibolo));
+      }
+    } else if ((*i).name == muvCN) {
+	  // Si pas bloc comprime -> 1 bit
+	  int lastbit = 1;
+	  block_type_reglage* reglage = fs->lastReglage();
+	  block_type_param*   param = fs->lastParam();
+	  bool isComp = (!(fs->lastBoloComp() == NULL) &&
+	      (numero_block(fs->lastBoloComp()) != numero_block(fs->lastBolo())));
+	  unsigned int4* data = isComp ? fs->lastBoloComp()->data_bolo[ibolo] : NULL;
+      for (int imesure=0; imesure<nb_per_block*2; imesure++) {
+	    // Les deux premieres valeurs sont codees directement...
+	    if (isComp && (imesure>=2)) {
+	      int iExp = (imesure-2)/4 + 1;
+	      int expo = data[iExp] & 0xf;
+	      lastbit = 1 << expo;
+	    } else {
+	      lastbit = 1;
+	    }
+	    double noise = (
+	      bolo_muV(&param->param, &reglage->reglage, lastbit, ibolo) -
+	      bolo_muV(&param->param, &reglage->reglage, 0, ibolo)) /2.;
+        computedValue((*i),sample0+imesure,noise);
+	  }
+    }
+  }
+}
+
Index: trunk/Poubelle/archTOI.old/toillboloproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toillboloproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillboloproducer.h	(revision 534)
@@ -0,0 +1,23 @@
+// toillboloproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef TOILLBOLOPRODUCER_H
+#define TOILLBOLOPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TOILLBoloProducer : public TOILowLevProducer {
+public:
+  TOILLBoloProducer();
+  void handleBlock(ArchFileSet*); // push !
+  virtual string getName();
+
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toilldiluproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toilldiluproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toilldiluproducer.cc	(revision 534)
@@ -0,0 +1,154 @@
+// toilldiluproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "toilldiluproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+#define   dilDAC           "dilDAC"
+#define   dilSwitch        "dilSwitch"
+#define   voyantEVO        "voyantEVO"
+#define   voyantEVF        "voyantEVF"
+#define   commandeEV0      "commandeEV0"
+#define   commandeEVF      "commandeEVF"
+#define   commandeEVB      "commandeEVB"
+#define   commandeEVV      "commandeEVV"
+#define   pressEnt3He      "pressEnt3He"
+#define   debit3He         "debit3He"
+#define   pressSor3He      "pressSor3He"
+#define   pressEnt4He      "pressEnt4He"
+#define   debit4He         "debit4He"
+#define   pressSor4He      "pressSor4He"
+#define   pressAirVanne    "pressAirVanne"
+#define   pressPompChar    "pressPompChar"
+#define   pressMembrane    "pressMembrane"
+#define   pressExterne     "pressExterne"
+#define   tensPile10T      "tensPile10T"
+#define   tensPileP18D     "tensPileP18D"
+#define   tensPileM18D     "tensPileM18D"
+#define   tensPile10B      "tensPile10B"
+#define   tensPileP18B     "tensPileP18B"
+#define   tensPileM18B     "tensPileM18B"
+#define   tensPileCh       "tensPileCh"
+#define   swPile5          "swPile5"
+#define   swPile15         "swPile15"
+#define   tempCaissH1      "tempCaissH1"
+#define   tempCaissH2      "tempCaissH2"
+#define   tempCaissB1      "tempCaissB1"
+#define   tempCaissB2      "tempCaissB2"
+#define   tempCaissTHe     "tempCaissTHe"
+#define   tempCaissPiles   "tempCaissPiles"
+#define   tempCaissDrv     "tempCaissDrv"
+#define   pressHeBain      "pressHeBain"
+#define   pressPirani      "pressPirani"
+
+
+TOILLDiluProducer::TOILLDiluProducer()
+{
+  possibleTOIs.insert(TOI(dilDAC,        TOI::all,    "", "ADU"));  
+  possibleTOIs.insert(TOI(dilSwitch,     TOI::unspec, "", "LONGWORD"));  
+  
+  possibleTOIs.insert(TOI(voyantEVO,     TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(voyantEVF,     TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(commandeEV0,   TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(commandeEVF,   TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(commandeEVB,   TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(commandeEVV,   TOI::unspec, "", "BOOLEAN"));  
+  
+  possibleTOIs.insert(TOI(pressEnt3He,   TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(debit3He,      TOI::unspec, "", "microMoles"));  
+  possibleTOIs.insert(TOI(pressSor3He,   TOI::unspec, "", "bars"));  
+
+  possibleTOIs.insert(TOI(pressEnt4He,   TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(debit4He,      TOI::unspec, "", "microMoles"));  
+  possibleTOIs.insert(TOI(pressSor4He,   TOI::unspec, "", "bars"));  
+
+  possibleTOIs.insert(TOI(pressAirVanne, TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(pressPompChar, TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(pressMembrane, TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(pressExterne,  TOI::unspec, "", "bars"));  
+  
+  possibleTOIs.insert(TOI(tensPile10T,   TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPileP18D,  TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPileM18D,  TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPile10B,   TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPileP18B,  TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPileM18B,  TOI::unspec, "", "Volts"));  
+  possibleTOIs.insert(TOI(tensPileCh,    TOI::unspec, "", "Volts"));  
+
+  possibleTOIs.insert(TOI(swPile5,       TOI::unspec, "", "BOOLEAN"));  
+  possibleTOIs.insert(TOI(swPile15,      TOI::unspec, "", "BOOLEAN"));  
+
+  possibleTOIs.insert(TOI(tempCaissH1,   TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissH2,   TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissB1,   TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissB2,   TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissTHe,  TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissPiles,TOI::unspec, "", "Kelvin"));  
+  possibleTOIs.insert(TOI(tempCaissDrv,  TOI::unspec, "", "Kelvin"));  
+
+  possibleTOIs.insert(TOI(pressHeBain,   TOI::unspec, "", "bars"));  
+  possibleTOIs.insert(TOI(pressPirani,   TOI::unspec, "", "bars"));  
+}
+
+string TOILLDiluProducer::getName() {
+  return("TOILLDiluProducer 1.0");
+}
+
+#define COMPTOI(_toi_, _func_)                               \
+    if ((*i).name == _toi_) {                                 \
+      computedValue((*i),sample0, _func_(blk));      \
+    }
+
+void TOILLDiluProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_dilution* blk = fs->lastDilution();
+  long sample0 = numero_block(blk)*72;
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    COMPTOI(voyantEVO,      voyant_EVO) else
+    COMPTOI(voyantEVF,      voyant_EVF) else
+    COMPTOI(commandeEV0,    commande_EVO) else
+    COMPTOI(commandeEVF,    commande_EVF) else
+    COMPTOI(commandeEVB,    commande_EVB) else
+    COMPTOI(commandeEVV,    commande_EVV) else
+    COMPTOI(pressEnt3He,    pression_entree_3He) else
+    COMPTOI(debit3He,       debit_3He) else
+    COMPTOI(pressSor3He,    pression_sortie_3He) else
+    COMPTOI(pressEnt4He,    pression_entree_4He) else
+    COMPTOI(debit4He,       debit_4He) else
+    COMPTOI(pressSor4He,    pression_sortie_4He) else
+    COMPTOI(pressAirVanne,  pression_air_vanne) else
+    COMPTOI(pressPompChar,  pression_pompe_charbon) else
+    COMPTOI(pressMembrane,  pression_membranne) else
+    COMPTOI(pressExterne,   pression_externe) else
+    COMPTOI(tensPile10T,    tension_pile_10T) else
+    COMPTOI(tensPileP18D,   tension_pile_p18D) else
+    COMPTOI(tensPileM18D,   tension_pile_m18D) else
+    COMPTOI(tensPile10B,    tension_pile_10B) else
+    COMPTOI(tensPileP18B,   tension_pile_p18B) else
+    COMPTOI(tensPileM18B,   tension_pile_m18B) else
+    COMPTOI(tensPileCh,     tension_pile_Ch) else
+    COMPTOI(swPile5,        switch_pile_5) else
+    COMPTOI(swPile15,       switch_pile_15) else
+    COMPTOI(tempCaissH1,    temperature_caisson_haut1) else
+    COMPTOI(tempCaissH2,    temperature_caisson_haut2) else
+    COMPTOI(tempCaissB1,    temperature_caisson_bas1) else
+    COMPTOI(tempCaissB2,    temperature_caisson_bas2) else
+    COMPTOI(tempCaissTHe,   temperature_caisson_tube_helium) else
+    COMPTOI(tempCaissPiles, temperature_caisson_piles) else
+    COMPTOI(tempCaissDrv,   temperature_caisson_driver_moteur) else
+    COMPTOI(pressHeBain,    pression_helium_bain) else
+    COMPTOI(pressPirani,    pression_pirani)
+    if ((*i).name == dilDAC) {
+      int k = (*i).index;
+      computedValue((*i), sample0, blk->ADC_dil[k]);
+    } else
+    if ((*i).name == dilSwitch) {
+      computedValue((*i), sample0, blk->switch_dil);
+    }
+  }
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/toilldiluproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toilldiluproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toilldiluproducer.h	(revision 534)
@@ -0,0 +1,23 @@
+// toilldiluproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOILLDILUPRODUCER_H
+#define TOILLDILUPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TOILLDiluProducer : public TOILowLevProducer {
+public:
+  TOILLDiluProducer();
+  void handleBlock(ArchFileSet*); // push !
+  virtual string getName();
+
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toillgpsproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toillgpsproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillgpsproducer.cc	(revision 534)
@@ -0,0 +1,156 @@
+// toillgpsproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "toillgpsproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+#define   gpsTime          "gpsTime"
+#define   latitude         "latitude"
+#define   longitude        "longitude"
+#define   altitude         "altitude"
+#define   gpsQuality       "gpsQuality"
+#define   gpsNSat          "gpsNSat"
+#define   gpsHDOP          "gpsHDOP"
+#define   gpsGeoidSep      "gpsGeoidSep"
+
+
+TOILLGPSProducer::TOILLGPSProducer()
+{
+  possibleTOIs.insert(TOI(gpsTime,      TOI::unspec,   "", "seconds", "onboardGPS"));  
+  possibleTOIs.insert(TOI(latitude,     TOI::unspec,   "", "degrees", "onboardGPS"));  // + = NORTH
+  possibleTOIs.insert(TOI(longitude,    TOI::unspec,   "", "degrees", "onboardGPS"));  // + = EAST
+  possibleTOIs.insert(TOI(altitude,     TOI::unspec,   "", "meters",  "onboardGPS"));  
+  possibleTOIs.insert(TOI(gpsQuality,   TOI::unspec,   "", "flag",    "onboardGPS"));  
+  possibleTOIs.insert(TOI(gpsNSat,      TOI::unspec,   "", "integer", "onboardGPS"));  
+  possibleTOIs.insert(TOI(gpsHDOP,      TOI::unspec,   "", "real",    "onboardGPS"));  
+  possibleTOIs.insert(TOI(gpsGeoidSep,  TOI::unspec,   "", "meters",  "onboardGPS"));
+}
+
+string TOILLGPSProducer::getName() {
+  return("TOILLGPSProducer 1.0");
+}
+
+
+// GPGGA string : 
+// $hhmmss.ss,ddmm.mmmm,n,dddmm.mmmm,e,q,ss,y.y,a.a,z,,
+// $104020,3740.712,N,00400.781,W,0,00,01.0,0003,M,-050,M,,
+
+
+void TOILLGPSProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_gps* blk = fs->lastGPS();
+  long sample0 = numero_block(blk)*72;
+    
+  double gpsutc;        //  secondes depuis minuit
+  double gpslat;        //  degres, + = NORD
+  double gpslong;       //  degres, + = EST
+  double alt;           //  altitude en metres
+  int    quality;       //  0 = NO FIX, 1 = GPS FIX, 2 = DGPS FIX
+  int    nsat;          //  nombre de satellites utilises
+  double hdop;          //  horizontal dilution of precision
+  double gsep;          //  separation geoide en metres
+  
+  char* p = blk->gps;
+  char* fence = p+80;
+  if (*p!='$') return;
+  p++;
+  
+  // UTC
+  if (*p < '0' || *p > '9') return;
+  double t;
+  sscanf(p, "%lg", &t);
+  int h = int(t/10000); t -= h*10000;
+  int m = int(t/100);   t -= m*100;
+  gpsutc = h*3600. + m*60. + t;
+  p += 6;
+  if (*p != ',') return;
+  p++;
+  if (p>=fence) return;
+  
+  // LATITUDE
+  if (*p < '0' || *p > '9') return;
+  sscanf(p, "%lg", &t);
+  int d = int(t/100); t -= d*100;
+  t = d + t/60;
+  p += 8;
+  if (*p != ',') return; 
+  p++;
+  if (*p == 'S') t = -t;
+  gpslat = t;
+  p++;
+  if (*p != ',') return; 
+  p++;
+  if (p>=fence) return;
+
+  // LONGITUDE
+  if (*p < '0' || *p > '9') return;
+  sscanf(p, "%lg", &t);
+  d = int(t/100); t -= d*100;
+  t = d + t/60;
+  p += 9;
+  if (*p != ',') return; 
+  p++;
+  if (*p == 'W') t = -t;
+  gpslong = t;
+  p++;
+  if (*p != ',') return; 
+  p++;
+  if (p>=fence) return;
+
+  // QUALITY
+  quality = *p - '0';
+  if (quality < 0 || quality > 9) return;
+  p++;
+  if (*p != ',') return; 
+  p++;
+  if (p>=fence) return;
+  
+  // NSAT
+  if (*p < '0' || *p > '9') return;
+  sscanf(p, "%d", &nsat);
+  p += 2;
+  if (*p != ',') return; 
+  p++;
+  
+  // HDOP
+  if (*p < '0' || *p > '9') return;
+  sscanf(p, "%lg", &hdop);
+  while (*p != ',' && p<fence) p++;
+  if (*p != ',') return; 
+  p++;
+  
+  // Altitude
+  if (*p < '0' || *p > '9') return;
+  sscanf(p, "%lg", &alt);
+  while (*p != ',' && p<fence) p++;
+  if (*p != ',') return; 
+  p++;
+  if (*p != 'M') return; 
+  p++;
+  if (*p != ',') return; 
+  p++;
+
+  // Geoid separation
+  if ((*p < '0' || *p > '9') && *p != '-') return;
+  sscanf(p, "%lg", &gsep);
+  while (*p != ',' && p<fence) p++;
+  if (*p != ',') return; 
+  p++;
+  if (*p != 'M') return; 
+
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    if ((*i).name == gpsTime)        computedValue((*i), sample0, gpsutc);
+    if ((*i).name == latitude)       computedValue((*i), sample0, gpslat);
+    if ((*i).name == longitude)      computedValue((*i), sample0, gpslong);
+    if ((*i).name == altitude)       computedValue((*i), sample0, alt);
+    if ((*i).name == gpsQuality)     computedValue((*i), sample0, quality);
+    if ((*i).name == gpsNSat)        computedValue((*i), sample0, nsat);
+    if ((*i).name == gpsHDOP)        computedValue((*i), sample0, hdop);
+    if ((*i).name == gpsGeoidSep)    computedValue((*i), sample0, gsep);
+  }
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/toillgpsproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toillgpsproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillgpsproducer.h	(revision 534)
@@ -0,0 +1,24 @@
+// toillgpsproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOILLGPSPRODUCER_H
+#define TOILLGPSPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TOILLGPSProducer : public TOILowLevProducer {
+public:
+  TOILLGPSProducer();
+
+  virtual void handleBlock(ArchFileSet*);
+  virtual string getName();
+  
+};
+
+
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/toillgyroproducer.cc
===================================================================
--- trunk/Poubelle/archTOI.old/toillgyroproducer.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillgyroproducer.cc	(revision 534)
@@ -0,0 +1,64 @@
+// toillgyroproducer.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "toillgyroproducer.h"
+#include "archfileset.h"
+#include "toimanager.h"
+#include "requesthandler.h"
+
+#define gyroRaw    "gyroRaw"
+#define gyroV      "gyroV"
+#define gyroCal    "gyroCal"
+#define gyroSpeed  "gyroSpeed"
+
+TOILLGyroProducer::TOILLGyroProducer()
+{
+  possibleTOIs.insert(TOI(gyroRaw,   TOI::all, "", "ADU"));  
+  possibleTOIs.insert(TOI(gyroV,     TOI::all, "", "Volts"));
+  possibleTOIs.insert(TOI(gyroCal,   TOI::unspec, "", "deg/s/V", "theoric"));
+  possibleTOIs.insert(TOI(gyroSpeed, TOI::all, "", "deg/s", "theoric"));
+}
+
+string TOILLGyroProducer::getName() {
+  return("TOILLGyroProducer 1.0");
+}
+
+
+static inline long gyrRaw(block_type_gyro* blk, int igyro, int imesure) {
+  return blk->gyro[igyro][imesure]-32768;
+}
+
+static inline double gyrV(block_type_gyro* blk, int igyro, int imesure) {
+  return gyrRaw(blk, igyro, imesure) * 2. / 32768.; // +- 2V dynamique sur 16 bits;
+}
+
+static inline double gyrSpeed(block_type_gyro* blk, int igyro, int imesure) {
+  return gyrV(blk, igyro, imesure) * 10;
+}
+
+void TOILLGyroProducer::handleBlock(ArchFileSet* fs)
+{
+  block_type_gyro* blk = fs->lastGyro();
+  long sample0 = numero_block(blk)*72;
+  for (set<TOI>::iterator i = producedTOIs.begin(); i != producedTOIs.end(); i++) {
+    int igyro = (*i).index;
+    if ((*i).name == gyroRaw) {
+      for (int j=0; j<nb_per_block*2; j++) {
+        computedValue((*i),sample0+j, gyrRaw(blk,igyro,j));
+      }
+    } else if ((*i).name == gyroV) {
+      for (int j=0; j<nb_per_block*2; j++) {
+        computedValue((*i),sample0+j, gyrV(blk,igyro,j));
+      }
+    } else if ((*i).name == gyroCal) {
+      for (int j=0; j<nb_per_block*2; j++) {
+        computedValue((*i),sample0+j, 10);
+      }
+    } else if ((*i).name == gyroSpeed) {
+      for (int j=0; j<nb_per_block*2; j++) {
+        computedValue((*i),sample0+j, gyrSpeed(blk,igyro,j));
+      }
+    }
+  }
+}
+
Index: trunk/Poubelle/archTOI.old/toillgyroproducer.h
===================================================================
--- trunk/Poubelle/archTOI.old/toillgyroproducer.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/toillgyroproducer.h	(revision 534)
@@ -0,0 +1,23 @@
+// toillgyroproducer.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef TOILLGYROPRODUCER_H
+#define TOILLGYROPRODUCER_H
+
+#include "toiproducer.h"
+#include "ark.h"
+
+
+class TOILLGyroProducer : public TOILowLevProducer {
+public:
+  TOILLGyroProducer();
+  void handleBlock(ArchFileSet*); // push !
+  virtual string getName();
+
+};
+
+
+
+
+
+#endif
